#include "Spektrum.h"

Spektrum::Spektrum(int pinCanal, int valeurMin, int valeurMax)
{
  pinMode(pinCanal, INPUT);
  _pinCanal = pinCanal;
  _valeurMin = valeurMin;
  _valeurMax = valeurMax;
  valeur = 0;
  calibreMin = INIT_MIN;
  calibreMax = INIT_MAX;
  connectionEtablie = false;
}

int Spektrum::lire()
{
  {
    valeur = pulseIn(_pinCanal, HIGH, PERIODE);
    if (valeur > PWM_MIN && valeur < PWM_MAX) {
      if (valeur < calibreMin) calibreMin = valeur;
      if (valeur > calibreMax) calibreMax = valeur;
      connectionEtablie = true;
    }
    else
    {
      connectionEtablie = false;
    }
    return mapCanal(valeur);
  }
}

int Spektrum::mapCanal(int val)
{
  int i = map(val, calibreMin, calibreMax, _valeurMin, _valeurMax);
  if (i < _valeurMin) i = _valeurMin;
  if (i > _valeurMax) i = _valeurMax;
  return i;
}


