// Cette class permet de lire une voie de recpeteur Spektrum.
//
// Grég(ory) VIENOT - @ArtificeBoy
// v1 2015

#ifndef Spektrum_h
#define Spektrum_h
#include "Arduino.h"

#define PERIODE 20000   // Période (en micro-secondes) du signal PWM en sortie du recepteur (20000)
#define PWM_MIN 1000    // Durée de l'état haut minimal (en mili-secondes) du signal PWM en sortie du recepteur (1000)
#define PWM_MAX 2000    // Durée de l'état haut maximal (en mili-secondes) du signal PWM en sortie du recepteur (2000)
#define INIT_MIN 1200   // Valeur initiale de calibration pour l'état haut minimal (en mili-secondes) (1200)
#define INIT_MAX 1800   // Valeur initiale de calibration pour l'état haut maximal (en mili-secondes) (1800)

class Spektrum
{
  public:
    Spektrum(int pinCanal, int valeurMin, int valeurMax);
    int lire();              // Lit la valeur du canal
    bool connectionEtablie;  // Indique si le recepteur recoit un signal de la télécommande

  private:
    int mapCanal(int val);   // Map la valeur recu du canal sur la plage specifié par valeurMin et valeurMax
    int _pinCanal;           // Numéro de pin de l'input
    int _valeurMin;          // Borne minimale de mappage
    int _valeurMax;          // Borne maxiamle de mappage
    int valeur;              // Valeur brute lue à la sortie du recepteur
    int calibreMin;          // Plus petite valeur recue depuis le debut de la lecture
    int calibreMax;          // Plus grande valeur recue depuis le debut de la lecture
};

#endif
